/*
Copyright 1989 by the Movies of the Future Group
of the MIT Media Laboratory
All rights reserved.

Permission to use, copy, and modify this software and its
documentation for any purpose and without fee is hereby granted,
provided that the above copyright notice appear in all copies and that
both that copyright notice and this permission notice appear in
supporting documentation, and that the name of M.I.T. not be used in
advertising or publicity pertaining to distribution of the software
without specific, written prior permission.  This software or any
other copies thereof may not be provided or otherwise made available to
others.  No title to or ownership of the software is hereby transferred.
M.I.T. makes no representations about the suitability of this software for any
purpose.  It is provided "as is" without express or implied warranty.
*/

#include <syscall.h>
#include <errno.h>

extern int errno;

int write(fd, buff, count)
int fd;
char *buff;
unsigned int count;
{
    long position, lseek();
    int value;

/* Save position of file pointer just in case ENOSPC occurs */
    position = lseek(fd, 0L, 1);

/* Do the actual write() */
    value = syscall(SYS_write, fd, buff, count);

    if (value == count)
	return value;
    else {
    /* Reset file pointer in case we ran out of space */
	if (value == -1 &&
	   (errno == ENOSPC || errno == EDQUOT) && position != -1) {
	    (void) lseek(fd, position, 0);
	}
	return writerr(value, fd, buff, count);
    }
}

