/***************************************************************\
*	sndfutil.h						*
*	Headers for some handy extra soundfile utilities	*
*	02dec90	dpwe						*
\***************************************************************/

#include "dpwelib.h"
#include "sndf.h"

#define CHARMAX  	127
#define	CHARBITS	8
#define SHORTMAX 	32767
#define SHORTBITS 	16
#define LONGMAX 	2147483647
#define LONGBITS	32

#define MAXCHANS 8	/* maximum number of channels Conv will believe */

int SFSampleSizeOf PARG((int format));
	/* return number of bytes per sample in given fmt */

void ConvertSampleBlockFormat PARG((char *inptr, char *outptr, 
				    int infmt, int outfmt, long samps));
int ConvertSoundFormat PARG((SFSTRUCT **psnd, int newFmt));

void ConvertChannels PARG((short *inBuf, short *outBuf, int inch, int ouch, 
			   long len));	/* # SAMPLE FRAMES to transfer */
void ConvertFlChans PARG((float *inBuf, float *outBuf, int inch, int ouch, 
			  long len));	/* # SAMPLE FRAMES to transfer */

void PrintSNDFinfo PARG((SFSTRUCT *theSound, char *name, char *tag, 
			 FILE *stream));
int PrintableStr PARG((char *s, int max));

long CvtChansAndFormat PARG((void *inbuf, void *outbuf, int inchans, 
			     int outchans, int infmt, int outfmt,long frames));
    /* convert the data format and the number of channels for a buffer 
       of sound.  Use smallest possible buffer space */

long ConvertChansAnyFmt PARG((void *inbuf, void *outbuf, int inchans, 
			      int outchans, int format, long frames));
    /* convert the number of channels in a sound of arbitrary format */
